function jsIsDate(sValue){
	
	/*
	By Daniel A. S. P. Nunes (12/08/2003)
	jsIsDate(sValue[,YearBoundary]);
	*/
		
	try{
				
		//Parmetro opcional YearBoundary: limite inferior para o ano. Default: 1753
		var YearBoundary = 1753;
		if (arguments.length > jsIsDate.length)
			YearBoundary = arguments[1];
			
		YearBoundary = parseInt(YearBoundary, 10);
		if (YearBoundary < 1753 || isNaN(YearBoundary)){
			alert("Parmetro YearBoundary invlido!");
			return false;
		}
				
		//Retira os espaos em branco
		sValue = jsTrim(sValue);
			
		if(sValue.length == 0)
			return false;
			
		var vData, vHora;
			
		/*
		Possibilidades para length < 10:
		Somente hora ou somente data!
		HH:MI:SS
		D/M/AAAA || DD/M/AAAA || D/MM/AAAA
		*/
		if(sValue.length < 10){
			if(sValue.indexOf(":") != -1)
				vHora = sValue.split(":");
			else
				vData = sValue.split("/");
		}
			
		//somente data
		if(sValue.length == 10)
			vData = sValue.split("/");
			
		//data e hora
		if(sValue.length > 10){
			//Para data e hora, DEVE existir um espao separando os dois
			var PosSpace = sValue.indexOf(" ");
			if(PosSpace != -1){
				vData = sValue.substr(0, PosSpace).split("/");
				vHora = sValue.substr(PosSpace+1).split(":");
			}
			else{
				return false;
			}
			
		}
			
		//valida a data
		if(typeof(vData) == 'object'){
			if(vData.length != 3){
				return false;
			}
			else{
				
				var DD   = parseInt(parseInt(vData[0].toString(), 10));
				var MM   = parseInt(parseInt(vData[1].toString(), 10));
				var AAAA = parseInt(parseInt(vData[2].toString(), 10));
				
				//verifica o dia
				if (DD < 1 || DD > 31 || isNaN(DD))
					return false;
				//verifica o ms
				if (MM < 1 || MM > 12 || isNaN(MM))
					return false;
				//verifica o ano
				if ((AAAA < YearBoundary) || isNaN(AAAA))
					return false;
					
				//verifica se o ano  bissexto
				var AnoBiss = 0;
				if ((AAAA%4 == 0 && AAAA%100 != 0) || AAAA%400 == 0)
					AnoBiss = 1;
				else
					AnoBiss = 0;
						
				//verifica o nmero de dias em fevereiro
				if ((MM == 2 && AnoBiss == 1 && DD > 29) || (MM == 2 && AnoBiss == 0 && DD > 28))
					return false;
				// Verifica o nmero de dias para os meses que tm apenas 30 dias
				if ((MM == 4 || MM == 6 || MM == 9 || MM == 11) && DD > 30){
					//alert('A data digitada  invlida!');
					return false;
				}
			}
		}
			
		//valida a hora
		if(typeof(vHora) == 'object'){
			if(vHora.length != 2 && vHora.length != 3){
				return false;
			}
			else{
				var max;
				for(var i=0; i<vHora.length;i++){
					if(isNaN(vHora[i])){
						return false;
					}
					else{
						if(i == 0)
							max = 23;
						else
							max = 59;
							
						if (!(parseInt(vHora[i].toString(), 10) >= 0 && parseInt(vHora[i].toString(), 10) <= max))
							return false;
					}
				}
			}
		}
		//Data vlida!
		return true;
	}//try
	catch(e){
		alert(e.description);
		return false;
	}
}//function jsIsDate

/*
jsLeft, jsRight esto no arquivo "functions.js"
*/

function ApplyDateMask(campo){
	
	/*
	Traduo de VBScript para JScript by Daniel A. S. P. Nunes (07/08/2003)
	*/

	if (window.event.keyCode != "8" && window.event.keyCode != "46"){
		if (jsRight(campo.value, 1) == "/" && jsLeft(jsRight(campo.value, 2), 1) == "/"){
			campo.value = jsLeft(campo.value, campo.value.length-1)
		}

		/*
		Coloca a '/' para o dia/ms
		*/
		if (campo.value.length == 2){
			if (jsRight(campo.value, 1) == "/")
				campo.value = "0" + campo.value
			else
				campo.value += "/"
		}

		/*
		Coloca a '/' para o ms/ano
		*/
		if (campo.value.length == 5){
			if (jsRight(campo.value, 1) == "/")
				campo.value = jsLeft(campo.value, 3) + "0" + campo.value.substr(3, 1) + "/"
			else
				campo.value += "/"
		}

		/*
		Se o primeiro dgito do ano for igual  dcada do ano atual na mquina
		do cliente e diferente do milnio, preenche o milnio e sculo automaticamente
		*/
			
		d = new Date();
		if (campo.value.length == 7)
			if (!isNaN(jsRight(campo.value, 1)))
				if (parseInt(jsRight(campo.value, 1), 10) == parseInt(d.getFullYear().toString().substr(2, 1), 10) && parseInt(jsRight(campo.value, 1), 10) != parseInt(d.getFullYear().toString().substr(0, 1), 10))
					campo.value = jsLeft(campo.value, 6) + d.getFullYear().toString().substr(0, 2) + campo.value.substr(6, 1)
	}
}

function ApplyTimeMask(campo){

	/*
	Traduo de VBScript para JScript by Daniel A. S. P. Nunes (08/08/2003)
	*/

	if (window.event.keyCode != "8" && window.event.keyCode != "46"){
		if (jsRight(campo.value, 1) == ":" && jsLeft(jsRight(campo.value, 2), 1) == ":"){
			campo.value = jsLeft(campo.value, campo.value.length-1);
		}
							
		if (campo.value.length == 2){
			if (jsRight(campo.value, 1) == ":")
				campo.value = "0" + campo.value;
			else
				campo.value += ":";
		}
	}
}

function ApplyDateTimeMask(campo){
	
	/*
	Traduo de VBScript para JScript by Daniel A. S. P. Nunes (07/08/2003)
	*/

	if (window.event.keyCode != "8" && window.event.keyCode != "46"){
		if (jsRight(campo.value, 1) == "/" && jsLeft(jsRight(campo.value, 2), 1) == "/"){
			campo.value = jsLeft(campo.value, campo.value.length-1)
		}

		/*
		Coloca a '/' para o dia/ms
		*/
		if (campo.value.length == 2){
			if (jsRight(campo.value, 1) == "/")
				campo.value = "0" + campo.value
			else
				campo.value += "/"
		}

		/*
		Coloca a '/' para o ms/ano
		*/
		if (campo.value.length == 5){
			if (jsRight(campo.value, 1) == "/")
				campo.value = jsLeft(campo.value, 3) + "0" + campo.value.substr(3, 1) + "/"
			else
				campo.value += "/"
		}

		/*
		Se o primeiro dgito do ano for igual  dcada do ano atual na mquina
		do cliente e diferente do milnio, preenche o milnio e sculo automaticamente
		*/
			
		d = new Date();
		if (campo.value.length == 7)
			if (!isNaN(jsRight(campo.value, 1)))
				if (parseInt(jsRight(campo.value, 1), 10) == parseInt(d.getFullYear().toString().substr(2, 1), 10) && parseInt(jsRight(campo.value, 1), 10) != parseInt(d.getFullYear().toString().substr(0, 1), 10))
					campo.value = jsLeft(campo.value, 6) + d.getFullYear().toString().substr(0, 2) + campo.value.substr(6, 1)
					
		/*
		Coloca um espao entre a data e a hora
		*/
		if (campo.value.length == 10)
			campo.value += " "
			
		if (jsRight(campo.value, 1) == ":" && jsLeft(jsRight(campo.value, 2), 1) == ":")
			campo.value = jsLeft(campo.value, campo.value.length-1);
							
		if (campo.value.length == 13){
			if (jsRight(campo.value, 1) == ":")
				campo.value = "0" + campo.value;
			else
				campo.value += ":";
		}
	}
}